JED(1)

NAME
Jed - programmers editor

SYNOPSIS
jed --version
jed-script --version
xjed --version

jed [--secure] [--batch|--script|--help] [options] file ...
jed-script [--secure] script file [script options] ...
xjed [--secure] [X options] [--batch|--script|--help] [options] file ...

DESCRIPTION
Jed - programmers editor

Features:

Color syntax highlighting. Emulation of Emacs, EDT, Wordstar, and Brief editors. Extensible in a language resembling C. Completely customizable. Editing TeX files with AUC-TeX style editing (BiBTeX support too). Folding support, and much more...

For complete documentation, see GNU info files, this manual only provides brief tutorial.

OPTIONS

  major options

--version
    prints the version and compiletime variables.
--help
    prints usage information.
--secure
    runs Jed in secure mode, e.g. you can't run any external commands with system() or run_shell_cmd().
--batch
    run Jed in batch mode. This is a non-interactive mode.
--script
    this is a mode like --batch but jed does not eval the startup files. It behaves like slsh. You must give the file that should be evaluated as second argument. It's the same as calling jed-script.

  minor options

-n
    do not load .jedrc file.
-a 'file'
    load file as user configuration file instead of .jedrc.
+ 'n'
    goto line n in buffer (notice that in order to this option to take effect, if must appear before the file name in the command line, like 'jed +3 file')
-g 'n'
    goto line n in buffer (notice that in order to this option to take effect, if must appear after the file name in the command line, like 'jed file -g 3')
-l 'file'
    load file as S-Lang code.
-f 'function'
    execute S-Lang function named function
-s 'string'
    search forward for string
-2
    split window
-i 'file'
    insert file into current buffer.

  X options
xjed accapts the common options like -display, -name, -fn and -geometry. Additionaly it accepts

-facesize SIZE, -fs SIZE
    if build with XRENDERFONT support, selects the font size SIZE. Use it with the option -fn to select a scalable font.
-foreground COLOR, -fg COLOR
    sets the foreground color.
-background COLOR, -bg COLOR
    sets the background color.
-fgMouse COLOR, -mfg COLOR
    sets the foreground color of the mouse pointer.
-bgMouse COLOR, -mbg COLOR
    sets the background color of the mouse pointer.
-Iconic, -ic
    start iconified.
-title NAME
    sets the window title to NAME.

For more options look at xterm.c.

CONFIGURATION
    Emulating Other Editors

JED's ability to create new functions using the S-Lang programming language as well as allowing the user to choose key bindings, makes the emulation of other editors possible. Currently, JED provides reasonable emulation of the Emacs, EDT, and Wordstar editors.

    Emacs Emulation

Emacs Emulation is provided by the S-Lang code in emacs.sl. The basic functionality of Emacs is emulated; most Emacs users should have no problem with JED. To enable Emacs emulation in JED, make sure that the line:

    () = evalfile ("emacs");

is in your jed.rc (.jedrc) startup file. JED is distributed with this line already present in the default jed.rc file.

    EDT Emulation

For EDT emulation, edt.sl must be loaded. This is accomplished by ensuring that the line:

    () = evalfile ("edt");

is in present in the jed.rc (.jedrc) Startup File.

    Wordstar Emulation

wordstar.sl contains the S-Lang code for JED's Wordstar emulation. Adding the line

    () = evalfile ("wordstar");

to your jed.rc (.jedrc) startup file will enable JED's Wordstar emulation.

RUN TIME

    Status line and Windows

JED supports multiple windows. Each window may contain the same buffer or different buffers. A status line is displayed immediately below each window. The status line contains information such as the JED version number, the buffer name, mode, etc. Please beware of the following indicators:

**
    buffer has been modified since last save.
%%
    buffer is read only.
m
    Mark set indicator. This means a region is being defined.
d
    File changed on disk indicator. This indicates that the file associated with the buffer is newer than the buffer itself.
s
    spot pushed indicator.
+
    Undo is enabled for the buffer.
[Narrow]
    Buffer is narrowed to a region of LINES.
[Macro]
    A macro is being defined.

    Mini-Buffer.

The Mini-Buffer consists of a single line located at the bottom of the screen. Much of the dialog between the user and JED takes place in this buffer. For example, when you search for a string, JED will prompt you for the string in the Mini-Buffer.

The Mini-Buffer also provides a direct link to the S-Lang interpreter. To access the interpreter, press Ctrl-X Esc and the S-Lang> prompt will appear in the Mini-Buffer. Enter any valid S-Lang expression for evaluation by the interpreter.

It is possible to recall data previously entered into the Mini-Buffer by using the up and down arrow keys. This makes it possible to use and edit previous expressions in a convenient and efficient manner.

    Basic Editing

Editing with JED is pretty easy - most keys simply insert themselves. Movement around the buffer is usually done using the arrow keys or page up and page down keys. If edt.sl is loaded, the keypads on VTxxx terminals function as well. Here, only the highlights are touched upon (cut/paste operations are not considered `highlights'). In the following, any character prefixed by the ^ character denotes a Control character. On keyboards without an explicit Escape key, Ctrl-[ will most likely generate and Escape character.

A prefix argument to a command may be generated by first hitting the Esc key, then entering the number followed by pressing the desired key. Normally, the prefix argument is used simply for repetition. For example, to move to the right 40 characters, one would press Esc 4 0 followed immediately by the right arrow key. This illustrates the use of the repeat argument for repetition. However, the prefix argument may be used in other ways as well. For example, to begin defining a region, one would press the Ctrl-@ key. This sets the mark and begins highlighting. Pressing the Ctrl-@ key with a prefix argument will abort the act of defining the region and to pop the mark. The following list of useful keybindings assumes that emacs.sl has been loaded.

Ctrl-L
    Redraw screen.
Ctrl-_
    Undo (Control-underscore, also Ctrl-X u').
Esc q
    Reformat paragraph (wrap mode). Used with a prefix argument. will justify the paragraph as well.
Esc n
    narrow paragraph (wrap mode). Used with a prefix argument will justify the paragraph as well.
Esc ;
    Make Language comment (Fortran and C)
Esc \\
    Trim whitespace around point
Esc !
    Execute shell command
Esc $
    Ispell word
Ctrl-X ?
    Show line/column information.
`
    quoted_insert --- insert next char as is (backquote key)
Esc s
    Center line.
Esc u
    Upcase word.
Esc d
    Downcase word.
Esc c
    Capitalize word.
Esc x
    Get M-x minibuffer prompt with command completion
Ctrl-X Ctrl-B
    pop up a list of buffers
Ctrl-X Ctrl-C
    exit JED
Ctrl-X 0
    Delete Current Window
Ctrl-X 1
    One Window.
Ctrl-X 2
    Split Window.
    Ctrl-X o
    Other window.
Ctrl-X b
    switch to buffer
Ctrl-X k
    kill buffer
Ctrl-X s
    save some buffers
Ctrl-X Esc
    Get "S-Lang>" prompt for interface to the S-Lang interpreter.
Esc .
    Find tag
Ctrl-@
    Set Mark (Begin defining a region). Used with a prefix argument aborts the act of defining the region and pops the Mark.

FILES
JED_ROOT/lib/*.sl
    these are the default runtime jed slang files
JED_ROOT/lib/site.sl
    This is the default startup file.
/etc/jed.rc
    The system wide configuration file.
~/.jedrc
    Per user configuration file.

AUTHOR
John E. Davis <davis@space.mit.edu>
    Jed's Author
--- This document was translated to nroff by "Boris D. Beletsky" <borik@isracom.co.il>